Bug 583689 - Library search feature is unaware of multilib
Library search feature is unaware of multilib
Product: Fedora
Classification: Fedora
Component: make (Show other bugs)
x86_64 Linux
low Severity low
: ---
: ---
Assigned To: Petr Machata
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2010-04-19 08:26 EDT by Matt McCutchen
Modified: 2015-05-04 21:35 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2010-12-03 10:40:55 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Patch series to add LIBDIRNAME, adjust search order, etc. (28.35 KB, patch)
2010-04-21 02:00 EDT, Matt McCutchen
no flags Details | Diff

  None (edit)
Description Matt McCutchen 2010-04-19 08:26:12 EDT
Description of problem:
GNU make's little-used "library search" feature, described in section 4.5.6 of the info docs, is unaware of multilib.  It is hard-coded to search in /lib, /usr/lib, and the configured libdir and does not have a way to specify the architecture of the target being built so that the appropriate library dirs can be searched.

On x86_64, the configured libdir is /usr/lib64, so make gets lucky and will find just about any library intended for consumption outside its package.  However, this doesn't address the problem of selecting a library that matches the target architecture.

I doubt this feature is important enough to be fixed in Fedora, but I still wanted to mention that it is broken.

Version-Release number of selected component (if applicable):
Comment 1 Petr Machata 2010-04-19 11:23:10 EDT
Actually make looks for -lblah, in this order:
 * in the current directory
 * in VPATH
 * in /lib
 * in /usr/lib
 * in LIBDIR, as specified during the build of make itself

So one way to fix this is to use the VPATH variable or the vpath directive:
$ echo 'all: -ldb-4.7; @echo $^' | make -f -
$ echo 'all: -ldb-4.7; @echo $^' | make -f - VPATH=/usr/lib64/
$ echo -e 'vpath lib%.so /usr/lib64\nall: -ldb-4.7; @echo $^' | make -f -

Using vpath directive strikes as a rather safe solution, since you can limit the effect only to libraries (as opposed to VPATH, which will affect everything).

One adjustment that I can think of is to put LIBDIR in front of /lib and /usr/lib.  Then 64bit make would favor 64bit libraries and 32bit make 32bit libraries, which is presumably what you usually want.  It's not bulletproof, but there's probably fewer cross builds done than straight ones, so it's "less broken".

Definitive solution would probably be to introduce LPATH, VPATH-like variable that would only be applicable for lookup of "-lblah" dependencies.  But I don't particularly like the idea of complicating this obscure edge of make further.
Comment 2 Matt McCutchen 2010-04-21 02:00:24 EDT
Created attachment 407991 [details]
Patch series to add LIBDIRNAME, adjust search order, etc.

How about a solution that exactly addresses the problem: introduce a LIBDIRNAME variable that determines the path component appended to /, /usr, and EXEC_PREFIX when searching for libraries.  Putting EXEC_PREFIX before / and /usr is also the right thing to do, because "local" dirs belong first on search paths, though it will not give additional benefit in this case.

This is implemented, along with some code cleanup, in the attached patch series.  If it would be better to take the proposal upstream, I will do that.
Comment 3 Petr Machata 2010-05-28 12:33:00 EDT
Hey, I noticed that you took the report upstream.  Thanks.
Comment 4 Bug Zapper 2010-11-03 12:45:59 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 5 Bug Zapper 2010-12-03 10:40:55 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.